<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed } from 'vue';

const props = defineProps({
    variant:
    {
        type: String,
        default: "default"
    },
    extraClass:
    {
        type: String
    },
    to: {
        type: String,
        required: false
    },
    size: {
        type: String,
        default: ""
    },
    disabled: {
        type: Boolean,
        required: false
    },
    ellipsis: {
        type: Boolean,
        default: false,
        required: false
    }
});

const buttonStyle = computed(() => {
    switch (props.variant) {
        case "cancel":
            return "bg-rose-700 hover:bg-rose-800 text-white hover:text-white";
        case "confirm":
            return "bg-accent1-default hover:bg-accent1-hover text-accent1-text hover:text-accent1-text";
        case "disabled":
            return "bg-gray-300 pointer-events-none text-gray-500";
        case "accent1":
            return "bg-accent1-default hover:bg-accent1-hover text-accent1-text hover:text-accent1-text"
        case "accent2":
            return "bg-accent2-default hover:bg-accent2-hover text-accent2-text hover:text-accent2-text"
        case "none":
            return "";
        case "white":
            return "hover:bg-gray-100 text-gray-700 hover:text-black bg-white border border-gray-500";
        case "invert":
            return "hover:bg-gray-800 text-gray-200 hover:text-white";
        case "default-dark":
            return "hover:bg-gray-200 text-gray-700 hover:text-black";
        default:
            return "hover:bg-gray-100 text-gray-700 hover:text-black";
    }
});

const buttonSize = computed(() => {
    switch (props.size) {
        case "small":
            return "h-7 leading-7 text-xs px-2";
        case "large":
            return "h-12 leading-12 text-lg px-4";
        default:
            return "h-9 leading-9 text-sm px-4";
    }
});

let baseStyle = "rounded-xl uppercase align-middle inline-block w-full select-none text-center focus-within:outline-1 outline-0 focus:outline-1 touch-manipulation text-nowrap";

if (props.ellipsis === true) {
    baseStyle += " line-clamp-1 text-ellipsis"
};

</script>
<template>
    <button :class="[buttonStyle, extraClass, baseStyle, buttonSize]" v-if="!to" :disabled="disabled">
        <slot></slot>
    </button>
    <a class="hover:no-underline" :class="[buttonStyle, extraClass, baseStyle, buttonSize]" :href="to" target="_blank" role="button"
        rel="opener" v-else>
        <slot></slot>
    </a>
</template>
